<?php # $Id: serendipity.css.php,v 1.39 2005/03/02 09:23:33 garvinhicking Exp $
# Copyright (c) 2003-2005, Jannis Hermanns (on behalf the Serendipity Developer Team)
# All rights reserved.  See LICENSE file for licensing details

/* This is a small hack to allow CSS display during installations and upgrades */
define('IN_installer', true);
define('IN_upgrader', true);

include_once('serendipity_config.inc.php');

if (!isset($css_mode)) {
    if (!empty($serendipity['GET']['css_mode'])) {
        $css_mode = $serendipity['GET']['css_mode'];
    } else {
        $css_mode = 'serendipity.css';
    }
}

switch($css_mode) {
    case 'serendipity.css':
    default:
        $css_hook = 'css';
        $css_file = 'style.css';
        break;

    case 'serendipity_admin.css':
        $css_hook = 'css_backend';
        $css_file = 'admin/style.css';
        break;
}

header('Content-type: text/css');

function serendipity_printStylesheet($file) {
    global $serendipity;
    return str_replace(
             array(
               '{TEMPLATE_PATH}',
               '{LANG_DIRECTION}'
             ),

             array(
               dirname($file) . '/',
               LANG_DIRECTION
             ),

             @file_get_contents($file, 1));
}

if (IS_installed === false) {
    if (file_exists('templates/' . $serendipity['defaultTemplate'] . '/' . $css_file)) {
        echo serendipity_printStylesheet('templates/' . $serendipity['defaultTemplate'] . '/' . $css_file);
    }
    die();
}

$out = serendipity_printStylesheet(serendipity_getTemplateFile($css_file, ''));

serendipity_plugin_api::hook_event($css_hook, $out);

echo $out;
/* vim: set sts=4 ts=4 expandtab : */
?>
